#!/bin/sh
#brtgz=arm-buildroot-2016-08-18-5aaca1b35f.tar.gz
brtgz=buildroot_openlinux_kernel_3.14_wayland_20170630.tar.gz

KDIR=$(pwd)/linux

mkdir -p archives

cd archives

if [ ! -e ${brtgz} ]; then
  #wget -N http://openlinux.amlogic.com:8000/download/ARM/filesystem/${brtgz}
  wget -N http://openlinux2.amlogic.com:8000/download/ARM/filesystem/Linux_BSP/${brtgz}
fi

cd ..

if [ ! -e meson-mali-lib ]; then
  mkdir meson-mali-lib
  cd meson-mali-lib

  echo "Extracting meson mali lib from buildroot..."
  tar xzf ../archives/${brtgz} buildroot_openlinux/buildroot/package/meson-mali

  cd ..
fi

#if [ ! -e xf86-video-armsoc ]; then
#  git clone -b meson-drm https://github.com/superna9999/xf86-video-armsoc
#fi

if [ ! -e meson_gx_mali_450 ]; then
  #git clone -b DX910-SW-99002-r6p1-01rel0_meson_gx https://github.com/superna9999/meson_gx_mali_450
  git clone -b DX910-SW-99002-r7p0-00rel1_meson_gx https://github.com/superna9999/meson_gx_mali_450

  cd meson_gx_mali_450/

  ##patch -p1 < ../meson_gx_mali_450-4.14-build.patch
  #patch -p1 < ../meson_gx_mali_450-4.14.patch

else
  cd meson_gx_mali_450/
fi

cp -p ../patches/mali-lib-END_USER_LICENCE_AGREEMENT.txt ./END_USER_LICENCE_AGREEMENT.txt

#cp -p ../meson-mali-lib/buildroot_openlinux/buildroot/package/meson-mali/lib/arm64/r6p1/m450-X/libMali.so .
cp -p ../meson-mali-lib/buildroot_openlinux/buildroot/package/meson-mali/lib/arm64/r7p0/m450-X/libMali.so .

cd ..

if [ -e ${KDIR}/drivers/gpu ]; then
  echo "Integrating meson mali driver..."
  mkdir -p ${KDIR}/drivers/gpu/arm
  cp -apP meson_gx_mali_450/driver/src/devicedrv/mali ${KDIR}/drivers/gpu/arm/

  if ! grep -q CONFIG_MALI400 ${KDIR}/arch/arm64/configs/odroidc2_defconfig ; then
    cat <<EOFMALIDEFCFG | tee -a ${KDIR}/arch/arm64/configs/odroidc2_defconfig

CONFIG_MALI400=m
CONFIG_MALI450=y
# CONFIG_MALI470 is not set
# CONFIG_MALI400_DEBUG is not set
# CONFIG_MALI400_PROFILING is not set
# CONFIG_MALI400_UMP is not set
# CONFIG_MALI_DVFS is not set
CONFIG_MALI_DMA_BUF_MAP_ON_ATTACH=y
# CONFIG_MALI_SHARED_INTERRUPTS is not set
# CONFIG_MALI_PMU_PARALLEL_POWER_UP is not set
# CONFIG_MALI_DT is not set
# CONFIG_MALI_DEVFREQ is not set
# CONFIG_MALI_QUIET is not set
EOFMALIDEFCFG
  fi

  sed -i s/CONFIG_ARCH_EXYNOS4/CONFIG_ARCH_MESON/g ${KDIR}/drivers/gpu/arm/mali/Kbuild
  sed -i s/exynos4/meson/g ${KDIR}/drivers/gpu/arm/mali/Kbuild

  if ! grep -q 'arm/mali/' ${KDIR}/drivers/video/Kconfig ; then
    echo 'source "drivers/gpu/arm/mali/Kconfig"' >> ${KDIR}/drivers/video/Kconfig
  fi

  if ! grep -q 'arm/mali/' ${KDIR}/drivers/gpu/Makefile ; then
    echo 'obj-y += arm/mali/' >> ${KDIR}/drivers/gpu/Makefile
  fi
fi

echo OK
